* [PATCH 1/3] overlay: test visible whiteout issue after rename
@ 2016-06-22 11:38 Eryu Guan
2016-06-22 11:38 ` [PATCH 2/3] overlay: getcwd() after a failed rmdir Eryu Guan
` (2 more replies)
0 siblings, 3 replies; 4+ messages in thread
From: Eryu Guan @ 2016-06-22 11:38 UTC (permalink / raw)
To: fstests; +Cc: linux-unionfs, Eryu Guan
Test visible whiteout issue after renaming file from lowerdir to a
dir in upperdir.
Upstream commit 45d117389696 ("ovl: ignore lower entries when
checking purity of non-directory entries") fixed the issue
Signed-off-by: Eryu Guan <eguan@redhat.com>
---
tests/overlay/006 | 77 +++++++++++++++++++++++++++++++++++++++++++++++++++
tests/overlay/006.out | 2 ++
tests/overlay/group | 1 +
3 files changed, 80 insertions(+)
create mode 100755 tests/overlay/006
create mode 100644 tests/overlay/006.out
diff --git a/tests/overlay/006 b/tests/overlay/006
new file mode 100755
index 0000000..31f11ef
--- /dev/null
+++ b/tests/overlay/006
@@ -0,0 +1,77 @@
+#! /bin/bash
+# FS QA Test 006
+#
+# Test visible whiteout issue after renaming file from lowerdir to a dir in
+# upperdir.
+#
+# Upstream commit 45d117389696 ("ovl: ignore lower entries when checking purity
+# of non-directory entries") fixed the issue
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2016 Red Hat Inc., All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs overlay
+_supported_os Linux
+_require_scratch
+
+echo "Silence is golden"
+
+# Remove all files from previous tests
+_scratch_mkfs
+
+# Create test file/dir before mount
+mkdir $SCRATCH_DEV/$OVERLAY_LOWER_DIR
+mkdir $SCRATCH_DEV/$OVERLAY_UPPER_DIR
+touch $SCRATCH_DEV/$OVERLAY_LOWER_DIR/lowertestfile
+mkdir $SCRATCH_DEV/$OVERLAY_UPPER_DIR/uppertestdir
+
+_scratch_mount
+
+# rename lowertestfile to uppertestdir, this triggers copyup and creates
+# whiteout in $OVERLAY_UPPER_DIR
+mv $SCRATCH_MNT/lowertestfile $SCRATCH_MNT/uppertestdir
+# the lowertestfile can be removed
+rm $SCRATCH_MNT/uppertestdir/lowertestfile
+# no file no whiteout file in upptestdir
+ls $SCRATCH_MNT/uppertestdir
+
+# success, all done
+status=0
+exit
diff --git a/tests/overlay/006.out b/tests/overlay/006.out
new file mode 100644
index 0000000..675c1b7
--- /dev/null
+++ b/tests/overlay/006.out
@@ -0,0 +1,2 @@
+QA output created by 006
+Silence is golden
diff --git a/tests/overlay/group b/tests/overlay/group
index d8fc597..78a67bf 100644
--- a/tests/overlay/group
+++ b/tests/overlay/group
@@ -8,3 +8,4 @@
003 auto quick whiteout
004 attr auto copyup quick
005 auto copyup quick
+006 auto quick copyup whiteout
--
2.7.4
^ permalink raw reply related [flat|nested] 4+ messages in thread
* [PATCH 2/3] overlay: getcwd() after a failed rmdir
2016-06-22 11:38 [PATCH 1/3] overlay: test visible whiteout issue after rename Eryu Guan
@ 2016-06-22 11:38 ` Eryu Guan
2016-06-22 11:38 ` [PATCH 3/3] overlay: create new file over whiteout Eryu Guan
2016-06-23 12:08 ` [PATCH 1/3] overlay: test visible whiteout issue after rename Xiong Zhou
2 siblings, 0 replies; 4+ messages in thread
From: Eryu Guan @ 2016-06-22 11:38 UTC (permalink / raw)
To: fstests; +Cc: linux-unionfs, Eryu Guan
Test getcwd() failure after unsuccessful rmdir, the getcwd() call
should return the correct path.
Upstream commit ce9113bbcbf4 ("ovl: fix getcwd() failure after
unsuccessful rmdir") fixed this issue.
Signed-off-by: Eryu Guan <eguan@redhat.com>
---
tests/overlay/007 | 65 +++++++++++++++++++++++++++++++++++++++++++++++++++
tests/overlay/007.out | 2 ++
tests/overlay/group | 1 +
3 files changed, 68 insertions(+)
create mode 100755 tests/overlay/007
create mode 100644 tests/overlay/007.out
diff --git a/tests/overlay/007 b/tests/overlay/007
new file mode 100755
index 0000000..ccf2b75
--- /dev/null
+++ b/tests/overlay/007
@@ -0,0 +1,65 @@
+#! /bin/bash
+# FS QA Test 007
+#
+# Test getcwd() failure after unsuccessful rmdir
+#
+# Upstream commit ce9113bbcbf4 ("ovl: fix getcwd() failure after unsuccessful
+# rmdir") fixed this issue
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2016 Red Hat Inc. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs overlay
+_supported_os Linux
+_require_test
+
+rm -rf $TEST_DIR/$seq
+
+# make a non-empty dir $seq
+mkdir -p $TEST_DIR/$seq/$seq.sub
+# cd to it and call rmdir on it, rmdir should fail
+cd $TEST_DIR/$seq
+rmdir ../$seq >>$seqres.full 2>&1
+# getcwd should return the correct current dir
+pwd | _filter_test_dir
+
+# success, all done
+status=0
+exit
diff --git a/tests/overlay/007.out b/tests/overlay/007.out
new file mode 100644
index 0000000..86aabe4
--- /dev/null
+++ b/tests/overlay/007.out
@@ -0,0 +1,2 @@
+QA output created by 007
+TEST_DIR/007
diff --git a/tests/overlay/group b/tests/overlay/group
index 78a67bf..e29e540 100644
--- a/tests/overlay/group
+++ b/tests/overlay/group
@@ -9,3 +9,4 @@
004 attr auto copyup quick
005 auto copyup quick
006 auto quick copyup whiteout
+007 auto quick
--
2.7.4
^ permalink raw reply related [flat|nested] 4+ messages in thread
* [PATCH 3/3] overlay: create new file over whiteout
2016-06-22 11:38 [PATCH 1/3] overlay: test visible whiteout issue after rename Eryu Guan
2016-06-22 11:38 ` [PATCH 2/3] overlay: getcwd() after a failed rmdir Eryu Guan
@ 2016-06-22 11:38 ` Eryu Guan
2016-06-23 12:08 ` [PATCH 1/3] overlay: test visible whiteout issue after rename Xiong Zhou
2 siblings, 0 replies; 4+ messages in thread
From: Eryu Guan @ 2016-06-22 11:38 UTC (permalink / raw)
To: fstests; +Cc: linux-unionfs, Eryu Guan
Create file/dir over whiteout by another user, uid/gid of the
file/dir should be current fsuid/fsgid, not the mounter's.
This upstream kernel patch fixed the issue
d0e13f5 ovl: fix uid/gid when creating over whiteout
Signed-off-by: Eryu Guan <eguan@redhat.com>
---
tests/overlay/008 | 85 +++++++++++++++++++++++++++++++++++++++++++++++++++
tests/overlay/008.out | 3 ++
tests/overlay/group | 1 +
3 files changed, 89 insertions(+)
create mode 100755 tests/overlay/008
create mode 100644 tests/overlay/008.out
diff --git a/tests/overlay/008 b/tests/overlay/008
new file mode 100755
index 0000000..cb8667c
--- /dev/null
+++ b/tests/overlay/008
@@ -0,0 +1,85 @@
+#! /bin/bash
+# FS QA Test 008
+#
+# Create file/dir over whiteout by another user, uid/gid of the file/dir should
+# be current fsuid/fsgid, not the mounter's.
+#
+# This upstream kernel patch fixed the issue
+# d0e13f5 ovl: fix uid/gid when creating over whiteout
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2016 Red Hat Inc. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs overlay
+_supported_os Linux
+_require_scratch
+_require_user
+
+# Remove all files from previous tests
+_scratch_mkfs
+
+# Create test file on lower dir, and chown to fsgqa user
+lowerdir=$SCRATCH_DEV/$OVERLAY_LOWER_DIR
+mkdir $lowerdir
+touch $lowerdir/testfile
+chown fsgqa:fsgqa $lowerdir/testfile
+
+# chown upperdir to fsgqa user, so new file/dir can be created by the user
+upperdir=$SCRATCH_DEV/$OVERLAY_UPPER_DIR
+mkdir $upperdir
+chown fsgqa:fsgqa $upperdir
+
+_scratch_mount
+
+# Remove testfile, whiteout created in lowerdir
+rm -f $SCRATCH_MNT/testfile
+
+# Create new file over whiteout and check the file ownership
+_user_do "touch $SCRATCH_MNT/testfile"
+stat -c %U:%G-%F $SCRATCH_MNT/testfile
+
+# Create new dir over whiteout and check ownership again
+rm -f $SCRATCH_MNT/testfile
+_user_do "mkdir $SCRATCH_MNT/testfile"
+stat -c %U:%G-%F $SCRATCH_MNT/testfile
+
+# success, all done
+status=0
+exit
diff --git a/tests/overlay/008.out b/tests/overlay/008.out
new file mode 100644
index 0000000..6e17968
--- /dev/null
+++ b/tests/overlay/008.out
@@ -0,0 +1,3 @@
+QA output created by 008
+fsgqa:fsgqa-regular empty file
+fsgqa:fsgqa-directory
diff --git a/tests/overlay/group b/tests/overlay/group
index e29e540..874bfdd 100644
--- a/tests/overlay/group
+++ b/tests/overlay/group
@@ -10,3 +10,4 @@
005 auto copyup quick
006 auto quick copyup whiteout
007 auto quick
+008 auto quick whiteout
--
2.7.4
^ permalink raw reply related [flat|nested] 4+ messages in thread
* Re: [PATCH 1/3] overlay: test visible whiteout issue after rename
2016-06-22 11:38 [PATCH 1/3] overlay: test visible whiteout issue after rename Eryu Guan
2016-06-22 11:38 ` [PATCH 2/3] overlay: getcwd() after a failed rmdir Eryu Guan
2016-06-22 11:38 ` [PATCH 3/3] overlay: create new file over whiteout Eryu Guan
@ 2016-06-23 12:08 ` Xiong Zhou
2 siblings, 0 replies; 4+ messages in thread
From: Xiong Zhou @ 2016-06-23 12:08 UTC (permalink / raw)
To: Eryu Guan; +Cc: fstests, linux-unionfs
On Wed, Jun 22, 2016 at 07:38:56PM +0800, Eryu Guan wrote:
> Test visible whiteout issue after renaming file from lowerdir to a
> dir in upperdir.
>
> Upstream commit 45d117389696 ("ovl: ignore lower entries when
> checking purity of non-directory entries") fixed the issue
To this series, git am and test run looks ok.
Reviewed-by: Xiong Zhou <xzhou@redhat.com>
>
> Signed-off-by: Eryu Guan <eguan@redhat.com>
> ---
> tests/overlay/006 | 77 +++++++++++++++++++++++++++++++++++++++++++++++++++
> tests/overlay/006.out | 2 ++
> tests/overlay/group | 1 +
> 3 files changed, 80 insertions(+)
> create mode 100755 tests/overlay/006
> create mode 100644 tests/overlay/006.out
>
> diff --git a/tests/overlay/006 b/tests/overlay/006
> new file mode 100755
> index 0000000..31f11ef
> --- /dev/null
> +++ b/tests/overlay/006
> @@ -0,0 +1,77 @@
> +#! /bin/bash
> +# FS QA Test 006
> +#
> +# Test visible whiteout issue after renaming file from lowerdir to a dir in
> +# upperdir.
> +#
> +# Upstream commit 45d117389696 ("ovl: ignore lower entries when checking purity
> +# of non-directory entries") fixed the issue
> +#
> +#-----------------------------------------------------------------------
> +# Copyright (c) 2016 Red Hat Inc., All Rights Reserved.
> +#
> +# This program is free software; you can redistribute it and/or
> +# modify it under the terms of the GNU General Public License as
> +# published by the Free Software Foundation.
> +#
> +# This program is distributed in the hope that it would be useful,
> +# but WITHOUT ANY WARRANTY; without even the implied warranty of
> +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
> +# GNU General Public License for more details.
> +#
> +# You should have received a copy of the GNU General Public License
> +# along with this program; if not, write the Free Software Foundation,
> +# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
> +#-----------------------------------------------------------------------
> +#
> +
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +status=1 # failure is the default!
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +_cleanup()
> +{
> + cd /
> + rm -f $tmp.*
> +}
> +
> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/filter
> +
> +rm -f $seqres.full
> +
> +# real QA test starts here
> +_supported_fs overlay
> +_supported_os Linux
> +_require_scratch
> +
> +echo "Silence is golden"
> +
> +# Remove all files from previous tests
> +_scratch_mkfs
> +
> +# Create test file/dir before mount
> +mkdir $SCRATCH_DEV/$OVERLAY_LOWER_DIR
> +mkdir $SCRATCH_DEV/$OVERLAY_UPPER_DIR
> +touch $SCRATCH_DEV/$OVERLAY_LOWER_DIR/lowertestfile
> +mkdir $SCRATCH_DEV/$OVERLAY_UPPER_DIR/uppertestdir
> +
> +_scratch_mount
> +
> +# rename lowertestfile to uppertestdir, this triggers copyup and creates
> +# whiteout in $OVERLAY_UPPER_DIR
> +mv $SCRATCH_MNT/lowertestfile $SCRATCH_MNT/uppertestdir
> +# the lowertestfile can be removed
> +rm $SCRATCH_MNT/uppertestdir/lowertestfile
> +# no file no whiteout file in upptestdir
> +ls $SCRATCH_MNT/uppertestdir
> +
> +# success, all done
> +status=0
> +exit
> diff --git a/tests/overlay/006.out b/tests/overlay/006.out
> new file mode 100644
> index 0000000..675c1b7
> --- /dev/null
> +++ b/tests/overlay/006.out
> @@ -0,0 +1,2 @@
> +QA output created by 006
> +Silence is golden
> diff --git a/tests/overlay/group b/tests/overlay/group
> index d8fc597..78a67bf 100644
> --- a/tests/overlay/group
> +++ b/tests/overlay/group
> @@ -8,3 +8,4 @@
> 003 auto quick whiteout
> 004 attr auto copyup quick
> 005 auto copyup quick
> +006 auto quick copyup whiteout
> --
> 2.7.4
>
> --
> To unsubscribe from this list: send the line "unsubscribe fstests" in
> the body of a message to majordomo@vger.kernel.org
> More majordomo info at http://vger.kernel.org/majordomo-info.html
^ permalink raw reply [flat|nested] 4+ messages in thread
end of thread, other threads:[~2016-06-23 12:08 UTC | newest]
Thread overview: 4+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2016-06-22 11:38 [PATCH 1/3] overlay: test visible whiteout issue after rename Eryu Guan
2016-06-22 11:38 ` [PATCH 2/3] overlay: getcwd() after a failed rmdir Eryu Guan
2016-06-22 11:38 ` [PATCH 3/3] overlay: create new file over whiteout Eryu Guan
2016-06-23 12:08 ` [PATCH 1/3] overlay: test visible whiteout issue after rename Xiong Zhou
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox